/* zf17d.f -- translated by f2c (version 20000817).
   You must link the resulting object file with the libraries:
        -lf2c -lm   (in that order)
*/

#include "f2c.h"

/* Common Block Declarations */

struct {
    integer iter;
} zf17rr_;

#define zf17rr_1 zf17rr_

/* Table of constant values */

static integer c__17 = 17;

/* Subroutine */ int zf17d_c(S_fp funcd, doublereal *a, doublereal *b,
        doublereal *eps, doublereal *root, integer *itmax, integer *ierr)
{
    /* Initialized data */

    static doublereal zero = 0.;

    /* System generated locals */
    integer i__1;
    doublereal d__1, d__2;

    /* Local variables */
    static doublereal temp, swap, f;
    static integer i__;
    static doublereal dxold;
    extern /* Subroutine */ int utzf11_c(integer *, integer *);
    static doublereal df, fh, fl, dx, xh, xl;

    *ierr = 0;
    (*funcd)(a, &fl, &df);
    (*funcd)(b, &fh, &df);
    if (fl * fh < zero) {
        goto L10;
    }
    *ierr = 66;
    goto L90;
L10:
    if (fl >= zero) {
        goto L20;
    }
    xl = *a;
    xh = *b;
    goto L30;
L20:
    xh = *a;
    xl = *b;
    swap = fl;
    fl = fh;
    fh = swap;
L30:
    *root = (*a + *b) / 2;
    dxold = (d__1 = *b - *a, abs(d__1));
    dx = dxold;
    (*funcd)(root, &f, &df);
    i__1 = *itmax;
    for (i__ = 1; i__ <= i__1; ++i__) {
        zf17rr_1.iter = i__;
        if (((*root - xh) * df - f) * ((*root - xl) * df - f) >= zero ||
                (d__1 = f * 2, abs(d__1)) > (d__2 = dxold * df, abs(d__2))) {
            goto L40;
        }
        dxold = dx;
        dx = f / df;
        temp = *root;
        *root -= dx;
        if (temp == *root) {
            goto L80;
        }
        goto L50;
L40:
        dxold = dx;
        dx = (xh - xl) / 2;
        *root = xl + dx;
        if (xl == *root) {
            goto L80;
        }
L50:
        if (abs(dx) < abs(*eps)) {
            goto L80;
        }
        (*funcd)(root, &f, &df);
        if (f < zero) {
            goto L60;
        }
        xh = *root;
        fh = f;
        goto L70;
L60:
        xl = *root;
        fl = f;
L70:
        ;
    }
    *ierr = 65;
L90:
    utzf11_c(ierr, &c__17);
L80:
    return 0;
} /* zf17d_c */
